//------------------------------------------------------------------------
// File name...............: Operator.cpp
// Programmr..............: Bjrk Boye Busch
// Beskrivelse.............: Eksempler p definition og brug af funktions
//							 og operator overload
//------------------------------------------------------------------------

#include "Operator.h"

//-----------------------------------------------------------------------------------------
// Constructors, assignment og destructors
//-----------------------------------------------------------------------------------------

CxTid::CxTid ()							// default constuctor
{
	Time = 0;
}
CxTid::CxTid (const int T)				// alm. constuctor
{
	Time = T;
}

CxTid::CxTid (const CxTid& Tidi)		// copy constructor
{
	if (this != &Tidi)
	{
		Time = Tidi.Time;
	}
}

CxTid& CxTid::operator= (const CxTid& Tid2)	// CxTid = CxTid	assign
{
	if (this != &Tid2)
	{
		Time = Tid2.Time;
	}
	return (*this);
}

CxTid& CxTid::operator= (int T2)			// CxTid = int		assign
{
	Time = T2;
	return (*this);
}

CxTid::~CxTid ()						// destuctor
{
	// algoritme for nedlggelse (oprydning)
	// ved brug af dynamiske data (oprettet med new) frigres med delete
	// bemrk at der ogs kan laves operateroverload p new og delete
}





//-----------------------------------------------------------------------------------------
// Regneoperatorer med kun 1 operant
//-----------------------------------------------------------------------------------------

CxTid& CxTid::operator++ (void)				// prefix
{
	++Time;
	return (*this);
}
CxTid CxTid::operator++ (int dummy)			// postfix NB! value retur
{
	CxTid Help(*this);
	++Time;
	return (Help);
}


//-----------------------------------------------------------------------------------------
// Regneoperatorer med 2 operanter
//-----------------------------------------------------------------------------------------

CxTid& CxTid::operator+= (const CxTid& Tid2)	// CxTid += CxTid	member assign-addition
{
	Time = Time + Tid2.Time;	// algoritme for CxTid += CxTid
	return (*this);
}

CxTid& CxTid::operator+= (const int T2)			// CxTid += int		member assign-addition
{
	Time = Time + T2;			// algoritme for CxTid += int
	return (*this);
}

CxTid CxTid::operator+ (const CxTid& Tid2)	//CxTid + CxTid		member addition
{
	CxTid Temp(*this);
	Temp += Tid2;				// bruger foregende: CxTid += CxTid
	return (Temp);
}

CxTid CxTid::operator+ (const int T2)		//CxTid + int		member addition
{
	CxTid Temp(*this);
	Temp += T2;					// bruger foregende: CxTid += int
	return (Temp);
}

CxTid operator+ (const int T1, const CxTid& Tid2)	//int + CxTid	friend addition
{
	CxTid Temp(Tid2);
	Temp += T1;					// bruger foregende: CxTid += int
	return (Temp);
}


//-----------------------------------------------------------------------------------------
// Testoperatorer med 2 operanter
//-----------------------------------------------------------------------------------------

int CxTid::operator== (const CxTid& Tid2)	// CxTid == CxTid		member equal test
{
	int Test = (Time == Tid2.Time);	// algoritme for CxTid == CxTid
	return (Test);
}

int CxTid::operator== (const int T2)		// CxTid == int			member equal test
{
	int Test = (Time == T2);		// algoritme for CxTid == int
	return (Test);					// evt. kan foregende bruges, hvor T2 frst
}									// omdannes til CxTid med constuctor

int operator== (const int T1, const CxTid& Tid2)	//int == CxTid	friend equal test
{
	CxTid Temp(Tid2);
	int Test = (Temp == T1);		// bruger foregende for CxTid == int
	return (Test);
}


//-----------------------------------------------------------------------------------------
// cin og cout
//-----------------------------------------------------------------------------------------

void CxTid::Out(ostream& os)
{
	os << Time;
}

ostream& operator<< (ostream& os, CxTid Tid)
{
//	os << Tid.Time;		// Direkte brug: denne brug krver friend og
						// giver problermer med virtuelle
						// funktioner i forbindelse med polymorfi

	Tid.Out(os);		// alternativ lsning for udskrift,
						// hvor ostream-operant overfres til
						// en udskrift funktion
						// Definitionen af ostream kan gres uden friend
						// hvis Out er defineret som public
						// (definition kan derfor flyttes uden for class'en)
						// Out kan vre en virtuel funktion og giver ikke 
						// problemer med polymorfi
	return (os);
}

void CxTid::In(istream& is)		// public hjlpefunktion
{
	is >> Time;
}

istream& operator>> (istream& is, CxTid& Tid)
{
//	is >> Tid.Time ;	// Direkte brug: denne brug krver friend og
						// giver problermer med virtuelle
						// funktioner i forbindelse med polymorfi

	Tid.In(is);			// alternativ lsning jvnfr ostream

	return (is);
}

