//------------------------------------------------------------------------
// File name...............: Operator.h
// Programmr..............: Bjrk Boye Busch
// Beskrivelse.............: Eksempler p definition og brug af funktions
//							 og operator overload
//------------------------------------------------------------------------

#include <iostream.h>

class CxTid
{

public:
	//-----------------------------------------------------------------------------------------
// Constructors, assignment og destructors
	//-----------------------------------------------------------------------------------------
	CxTid	();									// default constuctor
	CxTid	(const int T);						// alm. constructor

	CxTid	(const CxTid& Timei);				// copy constructor

	CxTid&	operator= (const CxTid& Tid2);		// CxTid = CxTid		assign
	CxTid&	operator= (int T2);					// CxTid = int			assign

	~CxTid	();									// destructor

	
	//-----------------------------------------------------------------------------------------
	// Regneoperatorer med kun 1 operant
	//-----------------------------------------------------------------------------------------
	CxTid&	operator++ (void);					// ++CxTid				prefix
	CxTid	operator++ (int dummy);				// CxTid++				postfix NB! value retur


	//-----------------------------------------------------------------------------------------
	// Regneoperatorer med 2 operanter
	//-----------------------------------------------------------------------------------------
	CxTid& 	operator+= (const CxTid& Tid2);		// CxTid += CxTid		member assign-addition
	CxTid& 	operator+= (const int T2);			// CxTid += int			member assign-addition
	CxTid 	operator+  (const CxTid& Tid2);		// CxTid + CxTid		member addition
	CxTid 	operator+  (const int T2);			// CxTid + int			member addition
/**/friend CxTid  operator+ (const int T1, const CxTid& Tid2);	//int + CxTid	friend addition


	//-----------------------------------------------------------------------------------------
	// Testoperatorer med 2 operanter
	//-----------------------------------------------------------------------------------------
	int		operator== (const CxTid& Tid2);		// CxTid == CxTid		member equal test
	int		operator== (const int T2);			// CxTid == int			member equal test
/**/friend int	  operator== (const int T1, const CxTid& Tid2);	//int == CxTid	friend equal test


	//-----------------------------------------------------------------------------------------
	// cin og cout
	//-----------------------------------------------------------------------------------------
	void	Out(ostream& os);	// hjlpefunktion
/**/friend ostream& operator<< (ostream& os, CxTid Tid);

	void	In(istream& os);	// hjlpefunktion
/**/friend istream& operator>> (istream& os, CxTid& Tid);



private:

	int Time;

};



// Man kan udemrket pladsere friend definitioner i starten - lige fr public
// der er i eksemplet imidlertid foretaget en gruppering efter "temaer"

